<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use \Teknisa\GER\Services\CrudService;

class Pla03400LimiteDeNutrientePorServico extends \Zeedhi\Framework\Controller\Report {
    
    protected $environment;
    protected $crudService;
    
    public function __construct($reportService, $environment, $crudService) {
        $this->environment = $environment;
        $this->crudService = $crudService;
        parent::__construct($reportService);
    }
    
    protected $reportMapping = array (
        'PLA03400' => array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
              "CDFILIAL" => "P_CDFILIAL",
              "CDSERVFILI" => "P_CDSERVICO",
              "CDNUTRIENTEINI" => "P_CDNUTRIENTEINI",
              "CDNUTRIENTEFIN" => "P_CDNUTRIENTEFIN",
            )
        ),
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        if($row['T_NMSERVICO'] == 'T') {
            $conditions = array(
    			array(
    				'columnName' => 'CDFILIAL',
    				'operator' => '=',
    				'value' => $row['CDFILIAL']
    			),
    			array(
    				'columnName' => 'IDTIPOSERV',
    				'operator' => '=',
    				'value' => 'N'
    			),
    				array(
    				'columnName' => 'NRORG',
    				'operator' => '=',
    				'value' => $this->environment->getNrOrg()
    			)
    		);
    		$servicos = $this->crudService->getFilteredDataSet('servico',$conditions)->getRows();
            $cdservfili = '';
            foreach ($servicos as $servico) {
                $cdservfili = $cdservfili . $servico['CDSERVFILI'] . '_';
            }
        } else {
            $cdservfili = '';
            foreach ($row['NMSERVICO'] as $nmservico) {
                $cdservfili = $cdservfili . $nmservico['CDSERVFILI'] . '_';
            }
        }
        $row['CDSERVFILI'] = $cdservfili;
    }

}