<?php

namespace Teknisa\PLA\Modules\Relatorio\Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\Report\ReportService;

class Pla00113AnaliseDeRestricoesContratuais extends \Zeedhi\Framework\Controller\Report {

    protected $utilPla;
    protected $environment;
    protected $qr2Strategy;

    public function __construct(ReportService $reportService, \PLA\Util\Util $utilPla, $environment, $qr2Strategy) {
        $this->reportService = $reportService;
        $this->utilPla = $utilPla;
        $this->environment = $environment;
        $this->qr2Strategy = $qr2Strategy;
    }

	protected $reportMapping = array (
    	'PLA00100' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
			)
		),
        'PLA00101' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00102' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00103' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00104' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00105' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00106' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00107' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00108' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA00109' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA0010A' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                "P_CDFILIAL"       => "P_CDFILIAL",
                "P_CDSERVFILI"     => "P_CDSERVFILI",
                "P_DTPRIMDIASEM"   => "P_DTPRIMDIASEM",
                "P_DTULTIDIASEM"   => "P_DTULTIDIASEM",
                "P_DTPRIMDIAMES"   => "P_DTPRIMDIAMES",
                "P_DTULTIDIAMES"   => "P_DTULTIDIAMES"
            )
        ),
        'PLA0010C' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010D' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010G' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010H' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010M' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010N' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010E' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010I' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010F' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010J' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010P' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010Q' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010R' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010O' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010U' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010V' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010S' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010T' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010X' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010Y' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010K' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        ),
        'PLA0010L' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "NRORG"            => "P_NRORG",
                "CDSERVFILI"       => "P_NRLISTA",
                "MES_SELECIONADO"  => "P_DTMESCARD",
                "IDORDENAGR"       => "P_ORDENA",
                "L_AGRUPGRPRAT"    => "P_NRAGRUPGRPRAT",
                "L_GRUPOPRATOSERV" => "P_NRGRUPOPRATOSERV",
                "IDPRODDIVERG"     => "P_SODIVERGENTE",
                "CDPRODINI"        => "P_CDPRODINI",
                "CDPRODFIN"        => "P_CDPRODFIM",
                "IDTIPORESTRICAO"  => "P_IDTIPORESTRICAO"
            )
        )
	);

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row["NRORG"] = $this->environment->getNrOrg();
        $row['CDSERVFILI'] = $this->utilPla->insertLista($row['LISTASERV']);
        $row["L_AGRUPGRPRAT"] = isset($row["NMAGRUPGRPRAT"]) && is_array($row["NMAGRUPGRPRAT"]) ? "_" . implode("_", $row["NMAGRUPGRPRAT"]) . "_" : "T";
        $row["L_GRUPOPRATOSERV"] = isset($row["NMGRUPOPRATO"]) && is_array($row["NMGRUPOPRATO"]) ? "_" . implode("_", $row["NMGRUPOPRATO"]) . "_" : "T";
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }

    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
        $row = $request->getRow();
        $this->utilPla->deleteLista($row['CDSERVFILI']);
    }
}